## org.springframework.orm.jdo.support
Class SpringPersistenceManagerProxyBean

    java.lang.Object
      org.springframework.orm.jdo.JdoAccessor
          org.springframework.orm.jdo.support.SpringPersistenceManagerProxyBean

All Implemented Interfaces:
  FactoryBean<javax.jdo.PersistenceManager>, InitializingBean

    public class SpringPersistenceManagerProxyBean

extends JdoAccessor
implements FactoryBean<javax.jdo.PersistenceManager>

Proxy that implements the `PersistenceManager` interface, delegating to the current thread-bound PersistenceManager (the Spring-managed transactional PersistenceManager or the single OpenPersistenceManagerInView PersistenceManager, if any) on each invocation. This class makes such a Spring-style PersistenceManager proxy available for bean references.

The main advantage of this proxy is that it allows DAOs to work with a plain JDO PersistenceManager reference in JDO 2.1 style (see `PersistenceManagerFactory.getPersistenceManagerProxy()`), while still participating in Spring's resource and transaction management.

The behavior of this proxy matches the behavior that the JDO 2.1 spec defines for a PersistenceManager proxy. Hence, DAOs could seamlessly switch between `StandardPersistenceManagerProxyBean` and this Spring-style proxy, receiving the reference through Dependency Injection. This will work without any Spring API dependencies in the DAO code!

Note: In contrast to `StandardPersistenceManagerProxyBean`, this proxy works with JDO 2.0 and higher. It does not require JDO 2.1.

Since:
  3.0
Author:
  Juergen Hoeller
See Also:
  `StandardPersistenceManagerProxyBean`, `PersistenceManagerFactory.getPersistenceManagerProxy()`, `PersistenceManagerFactoryUtils.getPersistenceManager(javax.jdo.PersistenceManagerFactory, boolean)`, `PersistenceManagerFactoryUtils.releasePersistenceManager(javax.jdo.PersistenceManager, javax.jdo.PersistenceManagerFactory)`

Field Summary

Fields inherited from class org.springframework.orm.jdo.JdoAccessor
`logger`

Constructor Summary
`SpringPersistenceManagerProxyBean()`

Method Summary
`void` `afterPropertiesSet()` Eagerly initialize the JDO dialect, creating a default one for the specified PersistenceManagerFactory if none set.
`javax.jdo.PersistenceManager` `getObject()` Return an instance (possibly shared or independent) of the object managed by this factory.
`Class<? extends javax.jdo.PersistenceManager>` `getObjectType()` Return the type of object that this FactoryBean creates, or `null` if not known in advance.
`protected Class<? extends javax.jdo.PersistenceManager>` `getPersistenceManagerInterface()` Return the PersistenceManager interface to expose.
`protected boolean` `isAllowCreate()` Return whether the PersistenceManagerFactory proxy is allowed to create a non-transactional PersistenceManager when no transactional PersistenceManager can be found for the current thread.
`boolean` `isSingleton()` Is the object managed by this factory a singleton? That is, will `FactoryBean.getObject()` always return the same object (a reference that can be cached)?
`void` `setAllowCreate(boolean allowCreate)` Set whether the PersistenceManagerFactory proxy is allowed to create a non-transactional PersistenceManager when no transactional PersistenceManager can be found for the current thread.
`void` `setPersistenceManagerInterface(Class<? extends javax.jdo.PersistenceManager> persistenceManagerInterface)` Specify the PersistenceManager interface to expose, possibly including vendor extensions.

Methods inherited from class org.springframework.orm.jdo.JdoAccessor
`convertJdoAccessException, flushIfNecessary, getJdoDialect, getPersistenceManagerFactory, isFlushEager, setFlushEager, setJdoDialect, setPersistenceManagerFactory`

Methods inherited from class java.lang.Object
`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

Constructor Detail

### SpringPersistenceManagerProxyBean

    public SpringPersistenceManagerProxyBean()

Method Detail

### setPersistenceManagerInterface

    public void setPersistenceManagerInterface(Class<? extends javax.jdo.PersistenceManager> persistenceManagerInterface)

  Specify the PersistenceManager interface to expose, possibly including vendor extensions.

  Default is the standard `javax.jdo.PersistenceManager` interface.

### getPersistenceManagerInterface

    protected Class<? extends javax.jdo.PersistenceManager> getPersistenceManagerInterface()

  Return the PersistenceManager interface to expose.

### setAllowCreate

    public void setAllowCreate(boolean allowCreate)

  Set whether the PersistenceManagerFactory proxy is allowed to create a non-transactional PersistenceManager when no transactional PersistenceManager can be found for the current thread.

  Default is "true". Can be turned off to enforce access to transactional PersistenceManagers, which safely allows for DAOs written to get a PersistenceManager without explicit closing (i.e. a `PersistenceManagerFactory.getPersistenceManager()` call without corresponding `PersistenceManager.close()` call).

  See Also:
    `PersistenceManagerFactoryUtils.getPersistenceManager(javax.jdo.PersistenceManagerFactory, boolean)`

### isAllowCreate

    protected boolean isAllowCreate()

  Return whether the PersistenceManagerFactory proxy is allowed to create a non-transactional PersistenceManager when no transactional PersistenceManager can be found for the current thread.

### afterPropertiesSet

    public void afterPropertiesSet()

  Description copied from class: `JdoAccessor`
  Eagerly initialize the JDO dialect, creating a default one for the specified PersistenceManagerFactory if none set.

  Specified by:
    `afterPropertiesSet` in interface `InitializingBean`
  Overrides:
    `afterPropertiesSet` in class `JdoAccessor`

### getObject

    public javax.jdo.PersistenceManager getObject()

  Description copied from interface: `FactoryBean`
  Return an instance (possibly shared or independent) of the object managed by this factory.

  As with a `BeanFactory`, this allows support for both the Singleton and Prototype design pattern.

  If this FactoryBean is not fully initialized yet at the time of the call (for example because it is involved in a circular reference), throw a corresponding `FactoryBeanNotInitializedException`.

  As of Spring 2.0, FactoryBeans are allowed to return `null` objects. The factory will consider this as normal value to be used; it will not throw a FactoryBeanNotInitializedException in this case anymore. FactoryBean implementations are encouraged to throw FactoryBeanNotInitializedException themselves now, as appropriate.

  Specified by:
    `getObject` in interface `FactoryBean<javax.jdo.PersistenceManager>`
  Returns:
    an instance of the bean (can be `null`)
  See Also:
    `FactoryBeanNotInitializedException`

### getObjectType

    public Class<? extends javax.jdo.PersistenceManager> getObjectType()

  Description copied from interface: `FactoryBean`
  Return the type of object that this FactoryBean creates, or `null` if not known in advance.

  This allows one to check for specific types of beans without instantiating objects, for example on autowiring.

  In the case of implementations that are creating a singleton object, this method should try to avoid singleton creation as far as possible; it should rather estimate the type in advance. For prototypes, returning a meaningful type here is advisable too.

  This method can be called before this FactoryBean has been fully initialized. It must not rely on state created during initialization; of course, it can still use such state if available.

  NOTE: Autowiring will simply ignore FactoryBeans that return `null` here. Therefore it is highly recommended to implement this method properly, using the current state of the FactoryBean.

  Specified by:
    `getObjectType` in interface `FactoryBean<javax.jdo.PersistenceManager>`
  Returns:
    the type of object that this FactoryBean creates, or `null` if not known at the time of the call
  See Also:
    `ListableBeanFactory.getBeansOfType(java.lang.Class<T>)`

### isSingleton

    public boolean isSingleton()

  Description copied from interface: `FactoryBean`
  Is the object managed by this factory a singleton? That is, will `FactoryBean.getObject()` always return the same object (a reference that can be cached)?

  NOTE: If a FactoryBean indicates to hold a singleton object, the object returned from `getObject()` might get cached by the owning BeanFactory. Hence, do not return `true` unless the FactoryBean always exposes the same reference.

  The singleton status of the FactoryBean itself will generally be provided by the owning BeanFactory; usually, it has to be defined as singleton there.

  NOTE: This method returning `false` does not necessarily indicate that returned objects are independent instances. An implementation of the extended `SmartFactoryBean` interface may explicitly indicate independent instances through its `SmartFactoryBean.isPrototype()` method. Plain `FactoryBean` implementations which do not implement this extended interface are simply assumed to always return independent instances if the `isSingleton()` implementation returns `false`.

  Specified by:
    `isSingleton` in interface `FactoryBean<javax.jdo.PersistenceManager>`
  Returns:
    whether the exposed object is a singleton
  See Also:
    `FactoryBean.getObject()`, `SmartFactoryBean.isPrototype()`